﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;

namespace MVVMwithWPF.Converters
{
    class ParameterContainValueConverter : IValueConverter
    {
        public bool TrueValue { get; set; } = true;
        public bool FalseValue { get; set; } = false;

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            bool returnValue = FalseValue;
            string data = value?.ToString() ?? "";
            if (parameter is not string para)
                return returnValue;

            string[] split = para.Split("|");
            returnValue = split.Contains(data) ? TrueValue : FalseValue;
            return returnValue;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
